from common.seg import *
from typing import *
from typing import Any

Dt = Tuple[int, int]
Lin = Dict[int, List[int]]

def getSurvivingBetween(tss: Dict[int, Tissue], linss: Dict[Dt, Lin], t1: int, t2: int) -> List[int]: ...
def filterSurvivingUntil(tss: Dict[int, Tissue], linss: Dict[Dt, Lin], t2: int) -> None: ...
def fst(x: Tuple[T, U]) -> T: ...
def snd(x: Tuple[T, U]) -> U: ...
def filterT(ts: Tissue, cids: List[int]) -> None: ...
def filterL1(tss: Dict[int, Tissue]) -> None: ...
def filterL1Neigh(tss: Dict[int, Tissue]) -> Dict[int, Tissue]: ...
def filterL1_marker(tss: Dict[int, STissue]) -> None: ...
def filterL1_st(tss: Dict[int, STissue]) -> None: ...
def filterL1L2(tss: Dict[int, Tissue]) -> None: ...
def getTs(linFn: str) -> Tuple[int, int]: ...
def getTs1(linFn: str) -> Tuple[int, ...]: ...
def readLin1(linFn: str) -> Tuple[Dict[int, List[int]], Tuple[int, ...]]: ...
def readLins1(linDataLoc: str) -> List[Tuple[Dict[int, List[int]], Tuple[int, ...]]]: ...
def mkLinsSeries1(lins: Any) -> Any: ...
def after(t: Any, lt: Any) -> bool: ...
def before(t: Any, lt: Any) -> bool: ...
def between(linSeries: Any, t1: int, t2: int) -> List[Tuple[Tuple[int, int], Dict[int, List[int]]]]: ...
def mergeLins(lin1: Dict[int, List[int]], lin2: Dict[int, List[int]]) -> Dict[int, List[int]]: ...
def mergeLinss1(lins: List[Dict[int, List[int]]], acc: Dict[int, List[int]]) -> Dict[int, List[int]]: ...
def mergeLinss(lins: List[Dict[int, List[int]]]) -> Dict[int, List[int]]: ...
def concat(xss: List[List[T]]) -> List[T]: ...
def tSearchN(mss: List[Dict[int, List[int]]], r: int, n: int, c: int) -> List[int]: ...
def tSearch1(mss: List[Dict[int, List[int]]], r: int) -> List[int]: ...
def tSearch2(mss: List[Dict[int, List[int]]], r: int) -> List[int]: ...
def cvol(c: Cell) -> float: ...
def sumVol(cs: List[Cell], f: Callable[[Cell], float]=...) -> float: ...
def mergeCellVolsRefN(tss: List[Tissue], mss: List[Dict[int, List[int]]]) -> List[Dict[int, float]]: ...
def const1(c: T) -> int: ...
def mergeCellNsRefN(tss: List[Tissue], linss: List[Dict[int, List[int]]]) -> List[Dict[int, int]]: ...
def divOr0(n1: float, n2: float) -> float: ...
def mkSeries1(d: str, dExprs: str, linDataLoc: str, ft: Any=...) -> Tuple[Dict[int, STissue], Dict[Dt, Lin]]: ...
def mkSeriesGeom1(d: str, linDataLoc: str, ft: Any=...) -> Tuple[Dict[int, Tissue], Dict[Dt, Lin]]: ...
def mkSeriesIm0(dataDir: str, fid: Any=..., ft: Any=...) -> Any: ...
def invertMap(ln: Any) -> Any: ...
def updateCells(ts: Any, ts1: Any, iLn: Any) -> None: ...
def prev(t: Any) -> Any: ...
def succ(t: Any) -> Any: ...
def updateTs(tss: Any, linss: Any, tpoints: Any) -> Any: ...
def updateTsBF(tss: Any, fs: Any) -> Any: ...
def tFn(t: Any, ref: str=...) -> Any: ...
def betweenTs(t: Any, bounds: Any) -> Any: ...
def filterLinssBetween(linss: Any, bounds: Any) -> Any: ...
def filterTssBetween(tss: Any, tbounds: Any) -> Any: ...
